
VentilatorGrote=80;

VentilatorHoogte= 25;

GatDiameter = 4;

AfstandTussenDeGaten = 71.5;

AfstandTussenRadiatoren = 40;

MuurAfstandTotHartRadiator = 95;

MuurBevestigingHoogte = 30;

HoogteVerloop = 20;
HoogteTussenPlaten = 5;

extraRand = 1;  // extra uitstekende rand aan de ventilator voor de beugel
beugelDikte = 4;

BevestigingBoutDia = 4;
$fn=90;

BinnenDiepte=35;
BinnenHoogte=25;

module ventilator()
{
    afstandRand = (VentilatorGrote-AfstandTussenDeGaten)/2;
    difference()
    {
        cube([VentilatorGrote,VentilatorGrote,VentilatorHoogte]);
        translate([afstandRand,afstandRand,-1]) cylinder(d=GatDiameter,h=VentilatorHoogte+2);
        translate([afstandRand,VentilatorGrote-afstandRand,-1]) cylinder(d=GatDiameter,h=VentilatorHoogte+2);
        translate([VentilatorGrote-afstandRand,afstandRand,-1]) cylinder(d=GatDiameter,h=VentilatorHoogte+2);
        translate([VentilatorGrote-afstandRand,VentilatorGrote-afstandRand,-1]) cylinder(d=GatDiameter,h=VentilatorHoogte+2);
      translate([VentilatorGrote/2,VentilatorGrote/2,-1]) cylinder(d=  VentilatorGrote-afstandRand,h=VentilatorHoogte+2);
    }
}

module slotGat(d=2,l=5,h=3)
{
    hull()
    {
        translate([-l/2,0,0])cylinder(d=d,h=h);
        translate([l/2,0,0])cylinder(d=d,h=h);
    }
}

module beugel(linkerBeugel=true, support=false)
{
    afstand = VentilatorGrote-AfstandTussenDeGaten;
    yoffset=(linkerBeugel) ? 0: VentilatorGrote-afstand;
    ruimteTussenMuur = MuurAfstandTotHartRadiator-VentilatorGrote/2;
    beugelDikte = 4;
    difference()
    {
        union()
        {
            translate([-ruimteTussenMuur,yoffset-extraRand,-2*beugelDikte-2])cube([ruimteTussenMuur-8,afstand+2*extraRand,beugelDikte]);
        }
        // slotgat voor bevestiging aan het bakje
        translate([-1*ruimteTussenMuur/3-4,yoffset+afstand/2,-2*beugelDikte-2-1])slotGat(d=BevestigingBoutDia+0.3,l=BevestigingBoutDia*3+3,h=3*beugelDikte);
    }
    difference()
    {
        translate([-MuurAfstandTotHartRadiator+VentilatorGrote/2,yoffset-extraRand,-2*beugelDikte-2-MuurBevestigingHoogte]) cube([beugelDikte,afstand+2*extraRand,MuurBevestigingHoogte]);
        translate([-ruimteTussenMuur-1,yoffset+afstand/2,-2*beugelDikte-2-MuurBevestigingHoogte*2/3]) rotate([0,90,0])slotGat(d=BevestigingBoutDia+0.3,l=BevestigingBoutDia*2,h=beugelDikte+2);
    }
    // driehoekig verstekings stuk
    hull()
    {
    translate([-MuurAfstandTotHartRadiator+VentilatorGrote/2,yoffset-extraRand,-2*beugelDikte-2-MuurBevestigingHoogte/3]) cube([2,afstand+2*extraRand,MuurBevestigingHoogte/3]);
    translate([-MuurAfstandTotHartRadiator+VentilatorGrote/2,yoffset-extraRand,-2*beugelDikte-2]) cube([MuurBevestigingHoogte/2,afstand+2*extraRand,2]);
    }
    
    //schuine zijkant voor extra stevigheid
    kant = (linkerBeugel)?afstand+2*extraRand-1.2:-0;
    hull()
    {
    translate([-MuurAfstandTotHartRadiator+VentilatorGrote/2,yoffset-extraRand+kant,-2*beugelDikte-2-MuurBevestigingHoogte*3/4]) cube([2,1.2,MuurBevestigingHoogte*3/4]);
    translate([-MuurAfstandTotHartRadiator+VentilatorGrote/2,yoffset-extraRand+kant,-2*beugelDikte-2]) cube([ruimteTussenMuur*3/4,1.2,2]);
    }
    

}

module houder()
{
    // dit is een samengesteld ding met bakje en beugel toen beugel nog beide beugels maakte.
    afstand = VentilatorGrote-AfstandTussenDeGaten;
    ruimteTussenMuur = MuurAfstandTotHartRadiator-VentilatorGrote/2;
    for(linkerBeugel=[0:1])
    {
        yoffset=(linkerBeugel) ? 0: VentilatorGrote-afstand;
        difference()
        {
            union()
            {
                translate([- MuurAfstandTotHartRadiator+VentilatorGrote/2 +ruimteTussenMuur/3-10,yoffset-extraRand,-beugelDikte]) cube([MuurAfstandTotHartRadiator+VentilatorGrote/2-ruimteTussenMuur/3+10,afstand+2*extraRand,beugelDikte]);
                translate([-20-10,yoffset-extraRand,0])cube([20,afstand+2*extraRand,BevestigingBoutDia]);
            }
            // gaten voor de bouten
            translate([afstand/2,yoffset+afstand/2,-beugelDikte-1]) cylinder(d=BevestigingBoutDia,h=beugelDikte+2);
            translate([VentilatorGrote-afstand/2,yoffset+afstand/2,-beugelDikte-1]) cylinder(d=BevestigingBoutDia,h=beugelDikte+2);
            // grote gat eruit zodat er geen lucht wordt tegen gehouden
            translate([VentilatorGrote/2,VentilatorGrote/2,-beugelDikte-1]) cylinder(d=  VentilatorGrote-afstand/2,h=beugelDikte+2);
            // sleuf
            translate([-1*ruimteTussenMuur/3-2,yoffset+afstand/2,-2*beugelDikte-2-1])
            cylinder(d=BevestigingBoutDia+0.3,h=3*beugelDikte);
            translate([-1*ruimteTussenMuur/3-2,yoffset+afstand/2,-0.1])
            cylinder(d=2*BevestigingBoutDia+0.1,h=2*BevestigingBoutDia,$fn=6);
        }
    }
    translate([-2/3*ruimteTussenMuur-10,-extraRand,-beugelDikte]) bakje();
}

module fan()
{
    afstandRand =  (VentilatorGrote-AfstandTussenDeGaten)/2;
    translate([VentilatorGrote/2,VentilatorGrote/2,0]) cylinder(d=VentilatorGrote-afstandRand,h=1);
    verschil =  (VentilatorGrote - (AfstandTussenDeGaten - AfstandTussenRadiatoren)) * HoogteTussenPlaten/(HoogteVerloop+HoogteTussenPlaten);
    //verschil = ((VentilatorGrote-afstandRand) - (afstandRand+AfstandTussenRadiatoren))*(1-HoogteVerloop/(HoogteVerloop+HoogteTussenPlaten));
    hull()
    {
        translate([VentilatorGrote/2,VentilatorGrote/2,HoogteVerloop+HoogteTussenPlaten]) rotate([0,0,90]) slotGat(d=AfstandTussenRadiatoren,l=VentilatorGrote,h=1);
        translate([VentilatorGrote/2,VentilatorGrote/2,HoogteVerloop]) rotate([0,0,90]) slotGat(d=AfstandTussenRadiatoren,l=VentilatorGrote-verschil,h=1);
    }
    hull()
    {
        translate([VentilatorGrote/2,VentilatorGrote/2,HoogteVerloop]) rotate([0,0,90]) slotGat(d=AfstandTussenRadiatoren,l=VentilatorGrote-verschil,h=1);
        
        translate([VentilatorGrote/2,VentilatorGrote/2,1]) cylinder(d=VentilatorGrote-afstandRand,h=1);
    }
}

module fanplaat()
{
    afstandRand =  (VentilatorGrote-AfstandTussenDeGaten)/2;
    difference()
    {
        cube([VentilatorGrote,VentilatorGrote,1]);
        // grote gat in het midden      
        translate([VentilatorGrote/2,VentilatorGrote/2,-1]) cylinder(d=  VentilatorGrote-afstandRand,h=3);
        // boor gaten
        translate([afstandRand,afstandRand,-1]) cylinder(d=GatDiameter,h=3);
        translate([afstandRand,VentilatorGrote-afstandRand,-1]) cylinder(d=GatDiameter,h=3);
        translate([VentilatorGrote-afstandRand,afstandRand,-1]) cylinder(d=GatDiameter,h=3);
        translate([VentilatorGrote-afstandRand,VentilatorGrote-afstandRand,-1]) cylinder(d=GatDiameter,h=3);
    }
}
module bakje()
{
    afstand = VentilatorGrote-AfstandTussenDeGaten + 2*extraRand;
    wandDikte= 1.2;
    difference()
    {
        cube([BinnenDiepte+2*wandDikte,VentilatorGrote+2*extraRand,BinnenHoogte+1]);
        translate([wandDikte,wandDikte,1])cube([BinnenDiepte,VentilatorGrote+2*extraRand-2*wandDikte,BinnenHoogte+1]);
        
        // bodem gleuven
        translate([BinnenDiepte+wandDikte-10,afstand/2,-1]) 
           cylinder(d=BevestigingBoutDia+0.3,h=3);
        translate([BinnenDiepte+wandDikte-10,AfstandTussenDeGaten+afstand/2,-1]) 
           cylinder(d=BevestigingBoutDia+0.3,h=3);

        translate([BinnenDiepte/2-4.5,-1,8])cube([9,3,7]);
        translate([BinnenDiepte/2-4.5,VentilatorGrote,8])cube([9,3,7]);

        // gaten aan de ventialtor zijde
        translate([BinnenDiepte+2*wandDikte-1-0.4,VentilatorGrote/2-4-9,BinnenHoogte+1-9])cube([3,9,7]);
        translate([BinnenDiepte+2*wandDikte-1-0.4,VentilatorGrote/2+4,BinnenHoogte+1-9])cube([3,9,7]);
        translate([BinnenDiepte+2*wandDikte-1-0.4,VentilatorGrote*3/4,BinnenHoogte+1-9]) cube([3,9,7]);
    }
    // steun voor deksel schroefgat
    difference()
    {
        translate([3,3,0])cylinder(d=6,h=BinnenHoogte+1);
        translate([3,3,2])cylinder(d=2,h=BinnenHoogte+1);
    }
    // steun voor deksel schroefgat
    difference()
    {
        translate([BinnenDiepte+2*wandDikte-3,VentilatorGrote+2*extraRand-3,0])cylinder(d=6,h=BinnenHoogte+1);
        translate([BinnenDiepte+2*wandDikte-3,VentilatorGrote+2*extraRand-3,2])cylinder(d=2,h=BinnenHoogte+1);
    }
}
module deksel()
{
    wandDikte = 1.2;
    extraRuimte = 0.2;
    difference()
    {
        union()
        {
            translate([-extraRuimte,-extraRuimte,0])cube([BinnenDiepte+2*wandDikte+2*extraRuimte,VentilatorGrote+2*extraRand+2*extraRuimte,1]);
            translate([1,1,-1])cube([BinnenDiepte+2*wandDikte-2*(wandDikte+extraRuimte),VentilatorGrote+2*extraRand-2*(wandDikte+extraRuimte),1]);
        }
        // schroefgaten uitsparing
        translate([3,3,-2])cylinder(d=3.2,h=5);
        translate([3,3,-2])cylinder(d=6.5,h=2);
        translate([BinnenDiepte+2*wandDikte-3,VentilatorGrote+2*extraRand-3,-2])cylinder(d=3.2,h=5);
        translate([BinnenDiepte+2*wandDikte-3,VentilatorGrote+2*extraRand-3,-2])cylinder(d=6.5,h=2);
    }
    // extra rand om de deksel heen
    difference()
    {
        translate([-extraRuimte-wandDikte,-extraRuimte-wandDikte,-2])cube([BinnenDiepte+4*wandDikte+2*extraRuimte,VentilatorGrote+2*extraRand+2*extraRuimte+2*wandDikte,3]);
        translate([-extraRuimte,-extraRuimte,-3])cube([BinnenDiepte+2*wandDikte+2*extraRuimte,VentilatorGrote+2*extraRand+2*extraRuimte,5]);
    }
}

module compilatie()
{
    color("black") ventilator();
    houder();
    beugel(true);
    beugel(false);
    translate([0,0,VentilatorHoogte]) fan();
    translate([0,0,VentilatorHoogte]) fanplaat();
    
    translate([-BinnenDiepte-2*1.2-9.25,-extraRand,BinnenHoogte+1-beugelDikte+2]) deksel();
}
module printDelen()
{
    //fan();
    fanplaat();
     afstand = VentilatorGrote-AfstandTussenDeGaten;
    translate ([0,-5,-VentilatorGrote+extraRand+afstand])rotate([90,0,0])beugel(false,true);
    translate([0,VentilatorGrote,extraRand+afstand]) rotate([-90,0,0])beugel(true,true);
    translate([0,VentilatorGrote+5,beugelDikte]) houder();
    translate([-5,VentilatorGrote+VentilatorGrote/2-BinnenDiepte/2,1])rotate([0,180,0]) rotate([0,0,90]) deksel();
}
compilatie();

//ventilator();
//fanplaat();

//printDelen();
//fan();

//bakje();
//translate([-10,0,1])rotate([0,180,0])deksel();
//translate([0,0,4]) houder();
